--------------------------------------------------------------------------------
--                        KDFargels Regen Data                                --
--------------------------------------------------------------------------------

REGEN_CONDITION = { }
REGEN_CONDITION["NORMAL"] = 1
REGEN_CONDITION["SENSOR"] = 2
REGEN_CONDITION["REMOVE"] = 3

REGEN_TYPE = { }
REGEN_TYPE["ONESHOT"] = 1
REGEN_TYPE["REPEAT"]  = 2

REGEN_DATA =
{
-- 1 
	REGEN1 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = 8184, Y = 1080, RADIUS = 94,  DELAY = 20, 	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = 7769, Y = 1122, RADIUS = 115, DELAY = 20, 	MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN2 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = 6139, Y = 1524, RADIUS = 129, DELAY = 20, 	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = 5744, Y = 1619, RADIUS = 136, DELAY = 20, 	MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN3 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = 4033, Y = 1290, RADIUS = 143, DELAY = 20, 	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = 3606, Y = 1328, RADIUS = 143, DELAY = 20, 	MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN4 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = 2926, Y = 2550, RADIUS = 129, DELAY = 20, 	MOBCOUNT = 2,  MAXCOUNT = 4,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = 2547, Y = 2828, RADIUS = 143, DELAY = 20, 	MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN5 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = 2036, Y = 1591, RADIUS = 122, DELAY = 20, 	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = 1615, Y = 1914, RADIUS = 122, DELAY = 20, 	MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN6 =
	{
		{ MOBINDEX = "KDFargels_Guard01", 	X = 8149, Y = 1596, RADIUS = 200, DELAY = 0,  	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["ONESHOT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard03", 	X = 8149, Y = 1596, RADIUS = 200, DELAY = 0,  	MOBCOUNT = 1, MAXCOUNT = 1, REGEN_TYPE = REGEN_TYPE["ONESHOT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN7 =
	{
		{ MOBINDEX = "KDFargels_Guard02", 	X = 4756, Y = 2371, RADIUS = 200, DELAY = 0,  	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["ONESHOT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard03", 	X = 4756, Y = 2371, RADIUS = 200, DELAY = 0,  	MOBCOUNT = 1, MAXCOUNT = 1, REGEN_TYPE = REGEN_TYPE["ONESHOT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN8 =
	{
		{ MOBINDEX = "KDFargels_Guard01", 	X = 2836, Y = 1250, RADIUS = 200, DELAY = 0,  	MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["ONESHOT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard02", 	X = 2836, Y = 1250, RADIUS = 200, DELAY = 0,  	MOBCOUNT = 1, MAXCOUNT = 1, REGEN_TYPE = REGEN_TYPE["ONESHOT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN9 =
	{
		--  X = -1, Y = -1 :  Ʈ ġ ȯ
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180,  MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN10 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180,  MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN11 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180,  MOBCOUNT = 2,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180,  MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

-- 2 
	REGEN12 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 10,  	MOBCOUNT = 4, MAXCOUNT = 8, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 10,  	MOBCOUNT = 2,  MAXCOUNT = 4, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN13 =
	{
		{ MOBINDEX = "KDFargels_Guard01", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  	MOBCOUNT = 1,  MAXCOUNT = 4, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard02", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  	MOBCOUNT = 1,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard03", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN12_1 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  MOBCOUNT = 4,  MAXCOUNT = 12,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  MOBCOUNT = 3,  MAXCOUNT = 6,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN13_1 =
	{
		{ MOBINDEX = "KDFargels_Guard01", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard02", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Guard03", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30,  	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

-- 3 
	REGEN14 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN15 =
	{
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180, 	MOBCOUNT = 1,  MAXCOUNT = 1,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN16 =
	{
		{ MOBINDEX = "KDFargels_Spearman",  X = -1,   Y = -1, 	RADIUS = 200, DELAY = 180, 	MOBCOUNT = 2,  MAXCOUNT = 4,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN17 =
	{
		{ MOBINDEX = "KDFargels_Spearman",  X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 2,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Paladin", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN18 =
	{
		{ MOBINDEX = "KDFargels_Paladin", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 2,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN19 =
	{
		{ MOBINDEX = "KDFargels_Spearman",  X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 2,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN20 =
	{
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 282, DELAY = 20, 	MOBCOUNT = 2, MAXCOUNT = 4, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 282, DELAY = 20, 	MOBCOUNT = 4,  MAXCOUNT = 8, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN21 =
	{
		{ MOBINDEX = "KDFargels_Spearman",  X = -1,   Y = -1, 	RADIUS = 296, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Paladin", 	X = -1,   Y = -1, 	RADIUS = 296, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 296, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN22 =
	{
		{ MOBINDEX = "KDFargels_Paladin", 	X = -1,   Y = -1, 	RADIUS = 295, DELAY = 30, 	MOBCOUNT = 2,  MAXCOUNT = 4, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Archlord", 	X = -1,   Y = -1, 	RADIUS = 295, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 295, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN23 =
	{
		{ MOBINDEX = "KDFargels_Archlord", 	X = -1,   Y = -1, 	RADIUS = 232, DELAY = 180, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 232, DELAY = 180, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN24 =
	{
		{ MOBINDEX = "KDFargels_DKnight", 	X = -1,   Y = -1, 	RADIUS = 500, DELAY = 20, 	MOBCOUNT = 8, MAXCOUNT = 32, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN25 =
	{
		{ MOBINDEX = "KDFargels_Spearman",  X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN26 =
	{
		{ MOBINDEX = "KDFargels_Spearman",  X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 2,  MAXCOUNT = 4,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Paladin", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN27 =
	{
		{ MOBINDEX = "KDFargels_Paladin", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN28 =
	{
		{ MOBINDEX = "KDFargels_Spearman", 	X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},

	REGEN29 =
	{
		{ MOBINDEX = "KDFargels_Paladin",  X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 3,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_Mage", 		X = -1,   Y = -1, 	RADIUS = 200, DELAY = 30, 	MOBCOUNT = 1,  MAXCOUNT = 2,  REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},
	
	REGEN30 =
	{
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 282, DELAY = 20, 	MOBCOUNT = 2, MAXCOUNT = 4, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 282, DELAY = 20, 	MOBCOUNT = 4,  MAXCOUNT = 8, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},
	
	REGEN31 =
	{
		{ MOBINDEX = "KDFargels_FRanger", 	X = -1,   Y = -1, 	RADIUS = 282, DELAY = 20, 	MOBCOUNT = 2, MAXCOUNT = 4, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
		{ MOBINDEX = "KDFargels_FSpearman", X = -1,   Y = -1, 	RADIUS = 282, DELAY = 20, 	MOBCOUNT = 4,  MAXCOUNT = 8, REGEN_TYPE = REGEN_TYPE["REPEAT"], ROUTINE = "OBJECT_ROUTINE" },
	},
}

REGEN_DIALOG_DATA =
{
	REGEN_DIALOG1 =
	{
		{ FACECUT = "KDFargels_Torin", 	FILENAME = "KDFargels", INDEX = "Torin_FC01", DELAY = 0 },
	}
}
